' --------------------------------------------------------------------------------------
'
' AmpelThread.VB                                                  Ulrich Mller 20.06.02
'                                                                 PCS1700   VB.NET Final
' Betrieb einer Fugngerampel in zwei eigenen Threads :
' frmMain      : MainThread Steuerung des Betriebsablaufs, Bedieneroberflche
' ampelAuto    : Thread     Steuerung der Autoampel
' ampelFuss    : Thread     Steuerung der Fugngerampel
' umFish30.DLL : Thread     Zugriff auf das interface, durch MultiMediatimer gesteuert
' ft           : Instanz    von FishfFace, Zugriff auf das Interface ber umFish30.DLL
'
' Modell : Intelligent Interface mit Entensionmodul an COM1
'          ampelAuto mit Grn M1, Gelb M2 und Rot M3
'          ampelFuss mit Grn M5          und Rot M7
'
' -------------------------------------------------------------------------------------

Imports System.Threading
Imports FishFa30

Public Class frmMain
    Inherits System.Windows.Forms.Form

#Region " Vom Windows Form Designer generierter Code "

    Public Sub New()
        MyBase.New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Initialisierungen nach dem Aufruf InitializeComponent() hinzufgen

    End Sub

    ' Die Form berschreibt den Lschvorgang der Basisklasse, um Komponenten zu bereinigen.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Fr Windows Form-Designer erforderlich
    Private components As System.ComponentModel.IContainer

    'HINWEIS: Die folgende Prozedur ist fr den Windows Form-Designer erforderlich
    'Sie kann mit dem Windows Form-Designer modifiziert werden.
    'Verwenden Sie nicht den Code-Editor zur Bearbeitung.
    Friend WithEvents cmdAction As System.Windows.Forms.Button
    Friend WithEvents cmdEnde As System.Windows.Forms.Button
    Friend WithEvents cmdFuss As System.Windows.Forms.Button
    Friend WithEvents lblStrasse As System.Windows.Forms.Label
    Friend WithEvents lblFuss As System.Windows.Forms.Label
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.cmdAction = New System.Windows.Forms.Button()
        Me.cmdEnde = New System.Windows.Forms.Button()
        Me.cmdFuss = New System.Windows.Forms.Button()
        Me.lblStrasse = New System.Windows.Forms.Label()
        Me.lblFuss = New System.Windows.Forms.Label()
        Me.SuspendLayout()
        '
        'cmdAction
        '
        Me.cmdAction.Font = New System.Drawing.Font("Tahoma", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cmdAction.Location = New System.Drawing.Point(264, 168)
        Me.cmdAction.Name = "cmdAction"
        Me.cmdAction.Size = New System.Drawing.Size(112, 32)
        Me.cmdAction.TabIndex = 0
        Me.cmdAction.Text = "&START"
        '
        'cmdEnde
        '
        Me.cmdEnde.Font = New System.Drawing.Font("Tahoma", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cmdEnde.Location = New System.Drawing.Point(264, 128)
        Me.cmdEnde.Name = "cmdEnde"
        Me.cmdEnde.Size = New System.Drawing.Size(112, 32)
        Me.cmdEnde.TabIndex = 1
        Me.cmdEnde.Text = "&ENDE"
        '
        'cmdFuss
        '
        Me.cmdFuss.Font = New System.Drawing.Font("Tahoma", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cmdFuss.Location = New System.Drawing.Point(24, 144)
        Me.cmdFuss.Name = "cmdFuss"
        Me.cmdFuss.Size = New System.Drawing.Size(112, 32)
        Me.cmdFuss.TabIndex = 2
        Me.cmdFuss.Text = "&FuWunsch"
        '
        'lblStrasse
        '
        Me.lblStrasse.Font = New System.Drawing.Font("Tahoma", 12.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblStrasse.Location = New System.Drawing.Point(24, 16)
        Me.lblStrasse.Name = "lblStrasse"
        Me.lblStrasse.Size = New System.Drawing.Size(352, 24)
        Me.lblStrasse.TabIndex = 3
        Me.lblStrasse.Text = "Strae"
        Me.lblStrasse.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblFuss
        '
        Me.lblFuss.Font = New System.Drawing.Font("Tahoma", 12.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblFuss.Location = New System.Drawing.Point(24, 56)
        Me.lblFuss.Name = "lblFuss"
        Me.lblFuss.Size = New System.Drawing.Size(352, 24)
        Me.lblFuss.TabIndex = 4
        Me.lblFuss.Text = "Fugnger"
        Me.lblFuss.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'frmMain
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(400, 229)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.lblFuss, Me.lblStrasse, Me.cmdFuss, Me.cmdEnde, Me.cmdAction})
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle
        Me.MaximizeBox = False
        Me.Name = "frmMain"
        Me.Text = "AmpelThread : Einfache Fugngerampel"
        Me.ResumeLayout(False)

    End Sub

#End Region

    ' --- FishFace Klassen-Instanz ---------------------------------------------------

    Dim ft As New FishFace(False, True, 0)
    Dim ampelAuto As Thread
    Dim ampelFuss As Thread
    Dim autoRot As New AutoResetEvent(False)
    Dim fussRot As New AutoResetEvent(False)
    Dim fussWunsch As New AutoResetEvent(False)

    ' --- Interface-Belegung --------------------------------------------------------

    Const mAutoGruen = 1, mAutoGelb = 2, mAutoRot = 3
    Const mFussGruen = 5, mFussRot = 7
    Const ftiEin = 1, ftiAus = 0

    ' --- cmdEnde_Click : Beenden des Modellbetriebs bei Button = HALT ---------------
    '     bei Button = ENDE Beenden des Programms

    Private Sub cmdEnde_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdEnde.Click
        If cmdEnde.Text = "&HALT" Then
            ' --- Beenden des Ampelbetriebs -----------------------------
            lblStrasse.Text = "Beenden wird eingeleitet"
            ft.NotHalt = True          ' --- Schleifenende
            fussWunsch.Set()           ' --- Fugngerphase schalten
            ampelAuto.Join()           ' --- Warten auf Ende fussThread

            ft.CloseInterface()        ' --- Interface abschalten

            cmdAction.Enabled = True   ' --- Buttons sortieren
            cmdFuss.Enabled = False
            cmdEnde.Text = "&ENDE"
        Else
            ' --- Programmende -------------------------------------------
            Me.Close()
        End If
    End Sub

    ' --- frmMain_Closing : Schlieen der Form ablehnen, wenn das Modell noch luft ----

    Private Sub frmMain_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        If cmdEnde.Text = "&HALT" Then e.Cancel = True
    End Sub

    ' --- cmdAction_Click : Starten des Ampelbetriebs ------------------------

    Private Sub cmdAction_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdAction.Click
        Try
            ft.OpenInterface(Port.COM1, False)    ' --- Verbindung zum Interface COM1
            cmdAction.Enabled = False             ' --- Buttons sortieren
            cmdEnde.Text = "&HALT"
            lblStrasse.Text = "StrassenAmpel luft"
            lblFuss.Text = "Fugngerampel luft"
            cmdFuss.Enabled = True
            cmdEnde.Focus()

            ' --- Threads instanzieren, starten -------------------------------------

            ampelAuto = New Thread(AddressOf autoExecute)
            ampelFuss = New Thread(AddressOf fussExecute)

            ampelAuto.Start()
            ampelFuss.Start()

        Catch eft As FishFaceException
            lblStrasse.Text = eft.Message
            Return
        End Try
    End Sub

    ' --- cmdFuss_Click : Wunsch nach FugngerPahse anmelden --------------------

    Private Sub cmdFuss_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdFuss.Click
        fussWunsch.Set()
    End Sub

    ' --- autoExecute : Nutzroutine des AutoThread -------------------------------

    Private Sub autoExecute()
        Do
            ' --- Ruhezustand ----------------------------------------------------
            ft.SetMotor(mAutoGruen, ftiEin)
            lblStrasse.BackColor = Color.Lime

            ' --- Warten auf Anforderung FugngerPhase --------------------------
            fussWunsch.WaitOne()

            ' --- Schalten Gelb - Rot --------------------------------------------
            ft.SetMotor(mAutoGruen, ftiAus)
            ft.SetMotor(mAutoGelb, ftiEin)
            lblStrasse.BackColor = Color.Yellow
            ft.Pause(1500)
            ft.SetMotor(mAutoGelb, ftiAus)
            ft.SetMotor(mAutoRot, ftiEin)
            lblStrasse.BackColor = Color.Red

            ' --- Signalisieren : Rot ist geschaltet -----------------------------
            autoRot.Set()

            ' --- Warten auf Ende der Fugngerphase -----------------------------
            fussRot.WaitOne()

            ' --- Schalten Rot/Gelb - Grn ---------------------------------------
            ft.SetMotor(mAutoGelb, ftiEin)
            lblStrasse.BackColor = Color.Maroon
            ft.Pause(1000)
            ft.SetMotor(mAutoGelb, ftiAus)
            ft.SetMotor(mAutoRot, ftiAus)

        Loop While Not ft.Finish()
        lblStrasse.Text = "StraenAmpel steht"
    End Sub

    ' --- fussExecute : Nutzroutine FussThread -----------------------------------

    Private Sub fussExecute()
        Do
            ' --- Ruhezustand ---------------------------------------------------
            ft.SetMotor(mFussGruen, ftiAus)
            ft.SetMotor(mFussRot, ftiEin)
            lblFuss.BackColor = Color.Red

            ' --- Warten auf RotPhase der AutoAmpel -----------------------------
            autoRot.WaitOne()

            ' --- Schalten der Grn-Phase ---------------------------------------
            ft.SetMotor(mFussRot, ftiAus)
            ft.SetMotor(mFussGruen, ftiEin)
            lblFuss.BackColor = Color.Lime
            ft.Pause(3000)

            ' --- Signalisieren : Grnphase ist beendet --------------------------
            fussRot.Set()

        Loop While Not ft.Finish()
        lblFuss.Text = "FugngerAmpel steht"
    End Sub

End Class
